
/*

  Copy a ``fortran'' format file

*/

#include <stdio.h>
#include "datahdr.h"
#include "strmhdr.h"
#include "fstrmhdr.h"

static char *usage        = "USAGE: fcat <state> <infile> <outfile>\n" ;

extern void sums () ;

void get_params (state, file1, file2, argc, argv)
char **state, **file1, **file2 ;
int argc ;
char *argv [] ;
{
  if (argc != 4)
  {
    fprintf (stderr, usage) ;
    exit (1) ;
  }
  *state = argv [1] ;

  if (! strcmp (argv [2], "-"))
    *file1 = NULL ;
  else
    *file1 = argv [2] ;

  if (! strcmp (argv [3], "-"))
    *file2 = NULL ;
  else
    *file2 = argv [3] ;
}

void main (argc, argv)
int argc ;
char *argv [] ;
{
  char *state, *file1, *file2 ;
  DATA  *datas ;
  FDATA *data1, *data2 ;
  int   sparams [NUM_STT_PARAMS], params [128] ;
  float scoeffs [NUM_STT_COEFFS], coeffs [128] ;
  int l_time, l_space ;
  int num_params, num_coeffs ;

  get_params  (&state, &file1, &file2, argc, argv) ;

  datas = data_open_read (state) ;
  read_header (datas) ;
  read_coeffs (datas, scoeffs) ;
  read_params (datas, sparams) ;
  data_close  (datas) ;

  data1 = fdata_open_read (file1) ;
  fdata_read_header (data1, &num_params, params, &num_coeffs, coeffs) ;

  data2 = fdata_open_write (file2) ;
  fdata_write_header (data2, num_params, params, num_coeffs, coeffs) ;

  l_time  = sparams [STT_L_T] ;
  l_space = sparams [STT_L_X] * sparams [STT_L_Y] * sparams [STT_L_Z] ;
  fprintf (stderr, "l_t = %d, l_s = %d\n", l_time, l_space) ;

  fdata_read_field_begin  (data1) ;
  fdata_write_field_begin (data2) ;
  copy (data1, data2, l_time, l_space) ;
  fdata_write_field_end   (data2) ;

  fdata_close_read (data1) ;
  fdata_close (data2) ;

  exit (0) ;
}

